> For the complete documentation index, see [llms.txt](https://docs.swivel.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.swivel.finance/swivel-v2.0.0/developers/contract/contracts/vaulttracker.md).

# VaultTracker

## constructor

```solidity
  function constructor(
    uint256 m,
    address c,
    address s
  ) public
```

### Parameters:

| Name | Type    | Description                                                  |
| ---- | ------- | ------------------------------------------------------------ |
| `m`  | uint256 | Maturity timestamp of the new market                         |
| `c`  | address | cToken address associated with underlying for the new market |
| `s`  | address | address of the deployed swivel contract                      |

## addNotional

```solidity
  function addNotional(
    address o,
    uint256 a
  ) external returns (bool)
```

Adds notional to a given address

### Parameters:

| Name | Type    | Description               |
| ---- | ------- | ------------------------- |
| `o`  | address | Address that owns a vault |
| `a`  | uint256 | Amount of notional added  |

## removeNotional

```solidity
  function removeNotional(
    address o,
    uint256 a
  ) external returns (bool)
```

Removes notional from a given address

### Parameters:

| Name | Type    | Description                  |
| ---- | ------- | ---------------------------- |
| `o`  | address | Address that owns a vault    |
| `a`  | uint256 | Amount of notional to remove |

## redeemInterest

```solidity
  function redeemInterest(
    address o
  ) external returns (uint256)
```

Redeem's interest accrued by a given address

### Parameters:

| Name | Type    | Description               |
| ---- | ------- | ------------------------- |
| `o`  | address | Address that owns a vault |

## matureVault

```solidity
  function matureVault(
    uint256 c
  ) external returns (bool)
```

Matures the vault

### Parameters:

| Name | Type    | Description                      |
| ---- | ------- | -------------------------------- |
| `c`  | uint256 | The current cToken exchange rate |

## transferNotionalFrom

```solidity
  function transferNotionalFrom(
    address f,
    address t,
    uint256 a
  ) external returns (bool)
```

Transfers notional from one address to another

### Parameters:

| Name | Type    | Description             |
| ---- | ------- | ----------------------- |
| `f`  | address | Owner of the amount     |
| `t`  | address | Recipient of the amount |
| `a`  | uint256 | Amount to transfer      |

## transferNotionalFee

```solidity
  function transferNotionalFee(
    address f,
    uint256 a
  ) external returns (bool)
```

Transfers, in notional, a fee payment to the Swivel contract without recalculating marginal interest for the owner

### Parameters:

| Name | Type    | Description         |
| ---- | ------- | ------------------- |
| `f`  | address | Owner of the amount |
| `a`  | uint256 | Amount to transfer  |

## balancesOf

```solidity
  function balancesOf(
    address o
  ) external returns (uint256, uint256)
```

Returns both relevant balances for a given user's vault

### Parameters:

| Name | Type    | Description               |
| ---- | ------- | ------------------------- |
| `o`  | address | Address that owns a vault |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.swivel.finance/swivel-v2.0.0/developers/contract/contracts/vaulttracker.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
